NumberToName := function(n)
	if n eq 1 then
		return [0,1];
	end if;
	if n eq 2 then
		return [1,1];
	end if;
	if n in [3 .. 5] then
		return [2,n-2];
	end if;
	if n in [6 .. 15] then
		return [3,n-5];
	end if;
	if n in [16 .. 61] then
		return [4,n-15];	
	end if;
	if n in [62 .. 120] then
		return [5, n-61];
	end if;
	if not(n in [1 .. 120]) then
		return n,"is not an integer between 1 and 120";
	end if;
end function;

NameToNumber := function(z)
        if z[1] eq 0 then
		if z[2] in [1] then               
			return 1;
		else
			return "not a known orbit";
		end if;
        end if;
        if z[1] eq 1 then
		if z[2] in [1] then               
			return 2;
		else
			return "not a known orbit";
		end if;
        end if;
        if z[1] eq 2 then
		if z[2] in [1 .. 3] then               
			return z[2] + 2;
		else
			return "not a known orbit";
		end if;
        end if;
        if z[1] eq 3 then
		if z[2] in [1 .. 10] then               
			return z[2] + 5;
		else
			return "not a known orbit";
		end if;
        end if;
        if z[1] eq 4 then
		if z[2] in [1..46] then               
			return z[2] + 15;
		else
			return "not a known orbit";
		end if;
        end if;
        if z[1] eq 5 then
		if z[2] in [1 ..59] then               
			return z[2] + 61;
		else
			return "not a known orbit";
		end if;
        end if;
	return "not a known orbit";
end function;

CollapsedAdjacencyMatrix :=
[
    [ 0, 1518, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 1, 1, 60, 560, 896, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 3, 3, 0, 0, 0, 168, 0, 0, 0, 0, 1344, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 5, 0, 5, 0, 0, 20, 128, 480, 0, 240, 0, 640, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 1, 0, 0, 1, 16, 0, 0, 120, 16, 60, 120, 320, 384, 480, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 77, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 0, 0, 0, 0, 330, 330, 704, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 9, 6, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 0, 144, 144, 0, 0, 0, 0, 0, 0, 
    0, 384, 384, 432, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 21, 0, 0, 0, 21, 0, 336, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210,
    210, 0, 0, 0, 0, 0, 0, 720, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 7, 14, 0, 0, 0, 21, 112, 0, 0, 0, 0, 0, 8, 8, 32, 0, 0, 0, 0, 0, 
    0, 0, 0, 84, 0, 0, 0, 448, 0, 224, 0, 0, 0, 0, 224, 0, 0, 336, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 1, 1, 0, 16, 60, 76, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 30, 30, 0, 384, 0, 60, 60, 320, 0, 0, 0, 0, 0, 0, 240, 240, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 1, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 12, 12, 0, 0, 32, 32, 0, 48, 
    48, 0, 0, 48, 0, 0, 0, 0, 0, 0, 32, 32, 0, 64, 0, 0, 0, 384, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 384, 384, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 1, 0, 4, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 4, 4, 0, 24, 16, 16, 0, 0, 0,
    64, 64, 108, 24, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0, 320, 0, 192, 128, 0, 0, 0, 
    0, 0, 0, 256, 256, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    ],
    [ 0, 0, 0, 1, 4, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 16, 0, 0, 0, 64, 10, 
    10, 16, 16, 0, 0, 0, 0, 240, 0, 112, 0, 0, 64, 96, 48, 96, 0, 144, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 96, 96, 0, 0, 384, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0 ],
    [ 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 
    0, 0, 0, 0, 0, 0, 60, 16, 140, 0, 0, 136, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 
    0, 40, 40, 20, 20, 60, 60, 80, 96, 96, 0, 0, 240, 240, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0 ],
    [ 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 15, 15, 0, 0, 0, 
    0, 0, 12, 0, 1, 1, 0, 0, 0, 6, 6, 0, 0, 64, 48, 48, 84, 0, 0, 0, 8, 8, 96, 
    96, 32, 32, 16, 16, 72, 72, 192, 0, 0, 96, 96, 192, 192, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 7, 0, 8, 0, 42, 14, 0, 0, 0, 7, 22, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 42, 0, 336, 0, 0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 448, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 224, 0, 0, 0, 0, 224,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 7, 0, 8, 0, 42, 14, 0, 0, 0, 22, 7, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 42, 0, 0, 336, 0, 0, 0, 112, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 448, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 224, 0, 0, 224, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 70, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 336, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 16, 0, 0, 0, 0, 0, 0, 210, 210, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 560, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 240, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 120, 120, 0, 0, 0, 
    0, 0, 0, 240, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 768, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 14, 7, 0, 0, 105, 0, 0, 0, 0, 0, 1, 0, 0, 0,
    0, 0, 0, 0, 14, 0, 0, 0, 0, 14, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 
    0, 112, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 224, 112, 0, 0, 0, 0, 0, 168, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 448, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
    ],
    [ 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 14, 7, 0, 0, 105, 0, 0, 0, 0, 1, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 14, 0, 0, 0, 42, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 56, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 
    112, 0, 168, 0, 0, 0, 0, 0, 0, 0, 0, 0, 112, 224, 0, 0, 0, 0, 168, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 448, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
    ],
    [ 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 35, 147, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 42, 140, 0, 0, 140, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 30, 30,
    35, 35, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 105, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 210, 252, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    ],
    [ 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 9, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 9, 0,
    0, 0, 0, 0, 72, 0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 0, 72, 168, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 0, 48, 0, 0, 0, 0, 0,
    64, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 192, 0, 0, 128, 128, 0, 0, 0, 0, 0, 0, 0,
    0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 288, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 9, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 6, 0,
    0, 0, 0, 72, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 168, 72, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 0, 48, 0, 0, 0, 0, 0, 
    64, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 128, 0, 128, 0, 0, 0, 0, 0, 0,
    0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 288, 0, 0, 0, 0, 0, 0, 0, 0 
    ],
    [ 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 12, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    13, 8, 0, 0, 24, 0, 0, 0, 0, 72, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 216, 120, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 16, 0, 8, 12, 12, 24, 0, 
    0, 96, 16, 0, 18, 0, 0, 0, 0, 0, 0, 0, 48, 0, 48, 0, 192, 0, 0, 144, 0, 0, 
    96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 288, 0, 0, 0, 
    0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 12, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    8, 13, 0, 0, 0, 24, 0, 0, 0, 0, 72, 0, 0, 0, 0, 18, 0, 0, 0, 0, 120, 216, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 16, 0, 8, 0, 12, 12, 0, 24, 
    96, 0, 0, 16, 18, 0, 0, 0, 0, 0, 0, 0, 0, 48, 0, 48, 0, 192, 0, 144, 0, 0, 
    0, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 288, 0, 0, 
    0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 1, 0, 4, 0, 8, 18, 0, 0, 32, 2, 2, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 27, 16, 16, 16, 0, 0, 0, 80, 80, 0, 0, 0, 0, 16, 32, 0, 64, 64, 128, 
    128, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 32, 
    0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 64, 64, 64, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 256, 256, 0, 0, 
    0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0,
    0, 12, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 96, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 24, 0, 0, 0, 0, 
    0, 0, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 96, 96, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 768 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 6, 0, 0, 0, 2, 0, 0, 0, 24, 
    8, 0, 6, 0, 14, 27, 8, 0, 0, 12, 0, 0, 0, 0, 0, 0, 72, 0, 0, 24, 0, 48, 0, 
    0, 0, 0, 0, 96, 48, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 48, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 64, 0, 192, 0, 0, 0, 128, 16, 0, 0, 0, 0, 0, 0, 0, 24, 32,
    0, 0, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 288, 0, 0, 96, 0, 0, 0, 0, 0,
    0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 6, 0, 0, 0, 2, 0, 24, 0, 
    0, 8, 6, 0, 27, 14, 8, 0, 0, 0, 12, 0, 0, 0, 0, 0, 72, 0, 24, 0, 48, 0, 0, 
    0, 0, 0, 96, 0, 24, 48, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 48, 0, 0,
    0, 0, 0, 0, 0, 64, 0, 192, 0, 0, 0, 0, 16, 128, 0, 0, 0, 0, 0, 0, 24, 0, 0, 
    32, 0, 0, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 288, 96, 0, 0, 0, 0, 0, 
    0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 1, 7, 0, 0, 0, 35, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 7, 7, 43, 168, 42, 7, 7, 168, 0, 0, 0, 0, 0, 0, 28, 28, 42, 42, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 0, 56, 56, 112, 84, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 84, 84, 0, 0, 0, 0, 0, 
    336, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 11, 0, 0, 0, 11, 0, 0, 0, 11, 0, 0, 0, 11, 0, 
    0, 0, 0, 0, 0, 0, 0, 165, 132, 55, 0, 0, 110, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 55, 55, 0, 66, 66, 55, 55, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 55, 55, 110, 110, 0, 0, 0, 0, 0, 0, 0, 0, 165, 165, 0, 0, 0, 0, 0, 
    0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 14, 84, 0, 0, 0, 2, 0, 0, 0, 32, 0, 0,
    0, 0, 0, 0, 0, 0, 36, 48, 95, 0, 0, 192, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 12, 12, 6, 6, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 16, 0, 0, 36, 36, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 48, 48, 0, 0, 0, 0, 0, 0, 72, 72, 144, 144, 0, 96, 96, 
    144, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 3, 0, 1, 0, 0, 1, 3, 0, 4, 0, 
    12, 0, 15, 0, 6, 0, 4, 0, 0, 25, 20, 0, 0, 24, 32, 12, 30, 0, 24, 4, 32, 12,
    0, 0, 0, 0, 0, 0, 36, 24, 0, 0, 0, 144, 0, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    24, 0, 0, 0, 0, 0, 0, 32, 32, 0, 0, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 36, 12, 
    64, 0, 0, 0, 128, 64, 32, 0, 192, 96, 96, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 3, 1, 0, 0, 0, 3, 1, 0, 0, 4, 0,
    12, 15, 0, 0, 6, 4, 0, 0, 20, 25, 0, 0, 24, 32, 12, 30, 0, 4, 24, 12, 32, 0,
    0, 0, 0, 0, 0, 24, 36, 0, 0, 0, 0, 144, 0, 96, 0, 0, 0, 0, 0, 0, 0, 0, 24, 
    0, 0, 0, 0, 0, 0, 32, 0, 0, 32, 0, 0, 96, 0, 0, 0, 0, 0, 0, 0, 0, 12, 36, 0,
    64, 0, 0, 64, 128, 0, 32, 96, 192, 0, 96, 0, 0, 0, 0, 0, 48, 0, 0, 0, 0, 0, 
    0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 5, 51, 0, 0, 0, 0, 0, 0, 0, 20, 0, 0, 
    0, 0, 0, 0, 0, 0, 90, 60, 120, 0, 0, 155, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 90, 90, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 10, 10, 0, 0, 0, 0, 0, 15, 15, 0, 0, 0, 0, 0, 0, 0, 0, 30, 30, 
    0, 0, 60, 60, 30, 30, 90, 90, 0, 0, 0, 0, 0, 0, 90, 90, 0, 0, 0, 0, 0, 0, 0,
    0, 180 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 24, 0, 0, 4, 4, 12, 12, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 96, 96, 0, 0, 0, 0, 0, 0, 0, 0, 32, 32, 12, 12, 0, 
    0, 0, 0, 0, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 80, 80, 112, 36, 12, 12, 32, 
    32, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 48, 192, 24, 0, 0, 0, 0, 0, 0, 0, 96, 
    96, 240, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 12, 0, 0, 19, 0, 0, 0, 0, 52, 52, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 48, 0, 0, 2, 2, 0, 0, 2, 2, 0, 0, 8, 8, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 48, 48, 0, 0, 48, 48, 0, 0, 32, 32, 0, 
    0, 0, 0, 48, 48, 0, 0, 96, 96, 80, 80, 0, 0, 0, 0, 0, 0, 144, 144, 0, 0, 0, 
    240, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 4, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 16, 0, 0, 0, 9, 6, 12, 0, 0, 0, 52, 52, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 24, 0, 0, 0, 0, 0, 0, 4, 4, 20, 20, 0, 0, 0, 
    0, 0, 0, 6, 16, 16, 0, 0, 64, 0, 0, 0, 0, 24, 24, 0, 0, 32, 96, 0, 0, 0, 0, 
    48, 48, 0, 0, 48, 48, 0, 0, 16, 16, 64, 64, 0, 0, 0, 0, 24, 24, 120, 120, 0,
    64, 64, 192, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1,
    1, 1, 4, 0, 0, 0, 0, 0, 4, 4, 0, 16, 0, 4, 4, 0, 0, 0, 0, 0, 0, 0, 0, 32, 
    32, 0, 0, 20, 20, 0, 64, 64, 48, 48, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 
    0, 16, 16, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 28, 28, 0, 0, 
    128, 128, 0, 0, 0, 0, 64, 64, 96, 96, 32, 32, 0, 112, 0, 0, 32, 32, 16, 16, 
    64, 64, 64, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 2, 4, 0, 14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 2, 0, 12, 12, 0, 0, 0, 10, 10, 0, 0, 0, 8, 0, 15, 0, 44, 44, 44, 44, 
    0, 0, 0, 0, 0, 0, 4, 4, 0, 0, 0, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 8, 8,
    0, 0, 16, 16, 8, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 16, 32, 32, 128, 0, 24, 24, 
    0, 0, 0, 0, 0, 0, 0, 0, 32, 32, 32, 32, 32, 32, 64, 0, 16, 16, 96, 96, 32, 
    32, 0, 0, 0, 256, 64 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 6, 6, 6, 6, 0, 0, 0, 0, 
    0, 0, 0, 0, 96, 0, 0, 0, 0, 144, 144, 0, 0, 0, 0, 6, 6, 0, 0, 0, 0, 24, 24, 
    0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 8, 8, 8, 8, 0, 0, 0, 0, 30, 30, 16, 16, 0, 0, 
    24, 24, 72, 72, 0, 0, 0, 0, 48, 48, 48, 0, 48, 48, 12, 12, 72, 72, 0, 32, 
    32, 0, 240 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 7, 0,
    0, 3, 0, 0, 3, 4, 0, 0, 6, 1, 0, 2, 26, 0, 0, 33, 6, 33, 30, 0, 0, 8, 0, 0, 
    24, 0, 12, 0, 54, 48, 0, 0, 48, 24, 48, 24, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 24, 40, 24, 0, 16, 16, 72, 0, 0, 0, 0, 0, 0, 6, 6, 0, 0, 48, 
    0, 0, 48, 40, 0, 104, 72, 24, 0, 24, 0, 8, 0, 0, 96, 120, 60, 0, 72, 0, 0, 
    0, 0, 48, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7, 3, 0,
    0, 3, 0, 3, 0, 4, 0, 0, 1, 6, 0, 2, 26, 0, 0, 33, 6, 30, 33, 0, 0, 0, 8, 24,
    0, 12, 0, 54, 0, 48, 0, 0, 24, 48, 24, 48, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 24, 0, 24, 40, 0, 16, 16, 0, 72, 0, 0, 0, 0, 0, 6, 0, 6, 48, 0, 
    0, 0, 40, 48, 104, 0, 24, 72, 24, 0, 8, 0, 0, 0, 120, 96, 0, 60, 0, 72, 0, 
    0, 0, 48, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 9,
    5, 6, 0, 0, 6, 6, 0, 0, 8, 3, 0, 6, 0, 26, 0, 33, 6, 0, 0, 33, 36, 0, 4, 12,
    12, 0, 12, 6, 6, 24, 48, 0, 12, 60, 0, 48, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 
    0, 0, 4, 0, 0, 8, 0, 32, 0, 24, 48, 60, 0, 0, 0, 0, 24, 0, 6, 6, 6, 24, 16, 
    0, 0, 48, 96, 24, 48, 72, 56, 24, 0, 0, 0, 0, 24, 168, 60, 0, 12, 12, 12, 0,
    48, 0, 24, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 5,
    9, 6, 0, 6, 0, 6, 0, 0, 3, 8, 0, 6, 0, 26, 0, 33, 6, 0, 0, 36, 33, 4, 0, 12,
    12, 12, 0, 6, 6, 24, 0, 48, 60, 12, 48, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 
    0, 4, 0, 0, 8, 0, 32, 0, 0, 48, 24, 0, 60, 0, 0, 24, 0, 0, 6, 6, 6, 16, 24, 
    0, 0, 96, 48, 48, 24, 56, 72, 0, 24, 0, 0, 0, 24, 60, 168, 12, 0, 12, 12, 0,
    0, 48, 24, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 3, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 72, 45, 0, 108, 72, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    12, 0, 27, 12, 0, 0, 0, 0, 0, 0, 0, 0, 9, 18, 0, 0, 0, 0, 0, 45, 0, 0, 36, 
    72, 0, 0, 36, 0, 30, 36, 36, 18, 54, 78, 36, 36, 9, 0, 36, 54, 45, 0, 144, 
    0, 72, 36, 216 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 3, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 72, 0, 0, 45, 72, 108, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    12, 27, 0, 12, 0, 0, 0, 0, 0, 0, 0, 18, 9, 0, 0, 0, 0, 45, 0, 0, 0, 36, 72, 
    0, 0, 0, 36, 36, 30, 18, 36, 78, 54, 36, 36, 0, 9, 54, 36, 0, 45, 144, 72, 
    0, 36, 216 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 0, 12, 6, 6, 0, 0, 3, 
    26, 0, 24, 0, 30, 0, 48, 0, 6, 72, 24, 72, 0, 0, 0, 1, 0, 4, 12, 6, 0, 4, 
    12, 10, 1, 0, 6, 0, 12, 0, 0, 0, 0, 0, 27, 0, 33, 0, 12, 24, 4, 36, 30, 12, 
    2, 28, 12, 36, 0, 8, 0, 48, 24, 8, 0, 28, 36, 24, 72, 36, 24, 24, 24, 24, 
    96, 60, 48, 96, 24, 72, 72 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 0, 12, 0, 6, 6, 0, 0, 26, 
    3, 24, 0, 30, 0, 0, 0, 48, 72, 6, 72, 24, 0, 0, 1, 0, 4, 0, 6, 12, 4, 0, 10,
    12, 0, 1, 6, 12, 0, 0, 0, 0, 0, 0, 0, 27, 0, 33, 24, 12, 4, 36, 12, 30, 28, 
    2, 12, 36, 8, 0, 48, 0, 8, 24, 28, 0, 24, 36, 72, 36, 24, 24, 24, 24, 60, 
    96, 48, 24, 96, 72, 72 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 6, 0, 0, 0, 24, 
    24, 3, 0, 24, 0, 72, 24, 24, 108, 0, 156, 0, 0, 0, 2, 0, 6, 6, 0, 20, 0, 2, 
    6, 0, 30, 12, 0, 0, 0, 4, 0, 0, 8, 0, 2, 26, 0, 12, 36, 12, 0, 6, 24, 2, 30,
    0, 24, 0, 48, 0, 36, 28, 24, 0, 36, 24, 36, 48, 24, 24, 0, 42, 90, 24, 0, 
    48, 56, 0, 84, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 0, 6, 0, 0, 0, 24, 0, 
    3, 24, 24, 0, 0, 24, 72, 108, 24, 156, 0, 0, 0, 2, 0, 6, 0, 0, 6, 0, 20, 6, 
    2, 30, 0, 12, 0, 0, 4, 0, 0, 8, 0, 2, 0, 0, 26, 36, 12, 12, 0, 24, 6, 30, 2,
    0, 24, 48, 0, 36, 0, 24, 28, 36, 0, 36, 24, 48, 24, 0, 24, 90, 42, 0, 24, 
    48, 0, 56, 84, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 2, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 2, 2, 1, 0, 0, 0, 3, 2, 0, 0, 0, 0, 5, 1, 0, 0, 18, 2, 2, 0, 0, 0, 20,
    0, 16, 3, 20, 16, 48, 16, 16, 76, 48, 96, 0, 0, 0, 0, 2, 8, 6, 0, 14, 0, 0, 
    0, 0, 16, 7, 0, 8, 0, 8, 0, 0, 0, 0, 4, 40, 24, 0, 0, 8, 4, 20, 2, 0, 32, 0,
    16, 8, 48, 16, 32, 24, 16, 24, 56, 40, 40, 32, 20, 24, 8, 48, 104, 72, 20, 
    32, 32, 0, 72, 112 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 2, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 2, 1, 2, 0, 0, 0, 2, 3, 0, 0, 0, 0, 5, 1, 0, 18, 0, 2, 2, 0, 0, 20, 0,
    16, 0, 20, 3, 16, 16, 48, 76, 16, 96, 48, 0, 0, 0, 0, 8, 2, 0, 6, 0, 14, 0, 
    0, 16, 0, 7, 8, 0, 8, 0, 0, 0, 0, 4, 0, 24, 40, 0, 0, 8, 4, 2, 20, 32, 0, 0,
    16, 48, 8, 32, 16, 16, 24, 56, 24, 40, 40, 32, 20, 8, 24, 104, 48, 20, 72, 
    32, 0, 32, 72, 112 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 6, 6, 3, 3, 0, 0, 0, 0, 
    0, 0, 6, 6, 5, 48, 48, 33, 33, 42, 42, 0, 0, 0, 0, 0, 0, 2, 2, 6, 6, 0, 0, 
    7, 7, 0, 2, 2, 0, 0, 12, 0, 0, 2, 2, 15, 15, 13, 13, 26, 18, 0, 0, 18, 18, 
    12, 12, 12, 12, 15, 15, 15, 15, 31, 31, 42, 42, 42, 12, 21, 21, 66, 66, 51, 
    51, 72, 42, 42, 168, 126 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 5, 0, 0, 10, 10, 0,
    15, 5, 15, 5, 40, 26, 26, 40, 40, 125, 105, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 5,
    5, 5, 0, 5, 0, 0, 0, 0, 0, 1, 1, 0, 5, 0, 5, 20, 5, 5, 5, 20, 20, 10, 5, 26,
    30, 40, 15, 25, 10, 15, 20, 15, 15, 20, 30, 66, 55, 20, 40, 30, 10, 15, 40, 
    50, 65, 60, 50, 160 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 5, 10, 0, 0, 10,
    5, 15, 5, 15, 40, 26, 26, 40, 40, 105, 125, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 5,
    5, 0, 5, 5, 0, 0, 0, 0, 0, 1, 1, 5, 0, 5, 0, 5, 20, 5, 5, 20, 20, 5, 10, 26,
    30, 15, 40, 10, 25, 20, 15, 15, 15, 30, 20, 66, 55, 40, 20, 10, 30, 40, 15, 
    50, 60, 65, 50, 160 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 2, 4, 2, 1, 3, 1, 0, 4, 2, 1, 5, 5, 0, 1, 12, 
    4, 18, 4, 19, 22, 32, 32, 57, 40, 70, 56, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 
    4, 2, 2, 4, 2, 6, 2, 2, 0, 4, 2, 17, 4, 11, 0, 14, 12, 10, 8, 19, 20, 4, 12,
    16, 24, 20, 18, 10, 50, 36, 20, 26, 18, 26, 24, 28, 32, 35, 36, 44, 20, 72, 
    32, 48, 76, 44, 76, 124 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 2, 4, 2, 1, 3, 1, 0, 2, 4, 5, 1, 0, 5, 12, 1, 
    18, 4, 19, 4, 22, 32, 32, 40, 57, 56, 70, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 4, 
    0, 2, 2, 4, 6, 2, 2, 2, 0, 2, 4, 4, 17, 0, 11, 12, 14, 10, 8, 20, 19, 12, 4,
    16, 24, 18, 20, 50, 10, 20, 36, 18, 26, 24, 26, 28, 32, 36, 35, 20, 44, 32, 
    72, 48, 44, 76, 76, 124 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 6, 2, 1, 0, 2, 6, 4, 2, 6, 
    0, 13, 6, 12, 14, 50, 42, 35, 28, 83, 91, 0, 0, 0, 0, 0, 0, 2, 0, 1, 0, 0, 
    3, 0, 3, 3, 2, 2, 0, 1, 8, 2, 1, 4, 2, 13, 8, 8, 0, 4, 9, 11, 5, 8, 12, 18, 
    28, 15, 17, 12, 36, 16, 12, 31, 29, 45, 36, 28, 34, 26, 17, 47, 40, 51, 33, 
    68, 76, 50, 71, 164 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 6, 1, 2, 2, 0, 4, 6, 6, 2, 
    13, 0, 12, 6, 14, 42, 50, 28, 35, 91, 83, 0, 0, 0, 0, 0, 0, 0, 2, 0, 1, 3, 
    0, 3, 0, 3, 2, 2, 1, 0, 8, 1, 2, 2, 4, 8, 13, 0, 8, 4, 9, 5, 11, 12, 8, 18, 
    28, 17, 15, 36, 12, 12, 16, 29, 31, 36, 45, 28, 34, 17, 26, 40, 47, 33, 51, 
    68, 50, 76, 71, 164 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 16, 0, 0, 0, 0, 0, 0, 
    70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 16, 0, 0, 0, 70, 0, 0, 0, 210, 0,
    0, 0, 0, 0, 0, 0, 560, 0, 0, 336, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15, 0, 16, 0, 0, 0, 0, 0, 0, 
    0, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 210, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 15, 0, 0, 70, 0, 0, 0, 210, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 560, 0, 0, 336, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    15, 0, 0, 45, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    45, 0, 90, 0, 0, 0, 0, 216, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 90,
    0, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 0, 0, 180, 0, 0, 0, 270, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 270, 0, 0, 0, 0, 0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    15, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    45, 0, 90, 0, 0, 0, 0, 216, 0, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 90,
    0, 60, 0, 0, 0, 0, 0, 0, 0, 0, 0, 225, 0, 0, 0, 0, 180, 0, 0, 0, 270, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 270, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 
    ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 12, 
    0, 2, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 6, 12, 0, 0, 36, 0, 36, 0, 36, 0, 0, 
    0, 48, 0, 72, 36, 144, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 3, 16, 12, 0, 54, 0,
    0, 0, 0, 32, 0, 0, 64, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 
    144, 0, 0, 0, 48, 0, 144, 48, 48, 0, 96, 0, 96, 0, 0, 0, 0, 0, 72, 144, 0, 
    0, 0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 12, 0, 
    2, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 6, 12, 0, 0, 36, 36, 0, 36, 0, 0, 0, 
    48, 0, 72, 0, 144, 36, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 16, 3, 0, 12, 0, 54,
    0, 0, 32, 0, 0, 64, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 144, 
    0, 0, 0, 48, 0, 144, 0, 48, 48, 96, 0, 96, 0, 0, 0, 0, 0, 72, 0, 0, 144, 0, 
    0, 0, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 4, 1,
    1, 3, 3, 12, 0, 0, 0, 4, 0, 0, 0, 32, 0, 20, 3, 12, 0, 0, 0, 0, 0, 0, 0, 48,
    24, 24, 0, 36, 0, 32, 0, 0, 24, 0, 96, 0, 0, 0, 0, 0, 4, 0, 19, 10, 0, 0, 0,
    0, 32, 0, 3, 0, 0, 0, 0, 0, 32, 32, 24, 0, 0, 0, 32, 0, 0, 0, 0, 36, 0, 0, 
    0, 96, 128, 0, 0, 0, 128, 96, 0, 32, 0, 32, 0, 0, 0, 144, 96, 24, 24, 48, 0,
    32, 32, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 4, 0, 1,
    1, 3, 3, 0, 12, 0, 0, 4, 0, 0, 0, 32, 0, 20, 3, 12, 0, 0, 0, 0, 0, 0, 0, 24,
    48, 0, 24, 0, 36, 32, 0, 0, 0, 24, 0, 96, 0, 0, 0, 0, 0, 4, 10, 19, 0, 0, 0,
    0, 0, 32, 3, 0, 0, 0, 0, 0, 32, 32, 0, 24, 0, 0, 0, 32, 0, 0, 36, 0, 0, 0, 
    0, 96, 0, 128, 0, 0, 96, 128, 32, 0, 32, 0, 0, 0, 144, 0, 24, 96, 48, 24, 0,
    32, 32, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 0, 0, 0, 0, 0, 0, 2,
    0, 0, 0, 0, 0, 0, 0, 2, 0, 12, 0, 12, 8, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 0, 
    16, 80, 0, 84, 0, 96, 0, 0, 0, 0, 48, 0, 0, 2, 0, 0, 18, 0, 0, 0, 3, 8, 32, 
    0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 96, 0, 0, 0, 0, 0, 12, 36, 0, 0, 0, 0, 
    0, 48, 0, 208, 48, 0, 0, 0, 32, 0, 96, 0, 24, 0, 96, 48, 0, 0, 144, 0, 32, 
    96, 48, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 0, 0, 0, 0, 0, 0, 0,
    2, 0, 0, 0, 0, 0, 0, 2, 12, 0, 0, 12, 8, 0, 0, 12, 0, 0, 0, 0, 0, 0, 0, 16, 
    0, 0, 80, 0, 84, 96, 0, 0, 0, 0, 0, 48, 2, 0, 0, 0, 0, 18, 0, 0, 8, 3, 0, 
    32, 0, 0, 0, 0, 0, 0, 16, 0, 0, 0, 96, 0, 0, 0, 0, 0, 0, 12, 0, 36, 0, 0, 0,
    0, 0, 48, 48, 208, 0, 0, 32, 0, 96, 0, 0, 24, 96, 0, 0, 48, 144, 0, 0, 96, 
    32, 48, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 0, 0, 0,
    7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 42, 
    35, 7, 21, 0, 0, 0, 84, 84, 0, 84, 0, 126, 0, 0, 0, 7, 0, 0, 0, 0, 28, 0, 1,
    2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14, 7, 14, 0, 0, 28, 0, 0, 0, 0, 0, 14, 42, 0,
    0, 28, 42, 0, 0, 0, 28, 0, 112, 0, 0, 0, 84, 0, 84, 84, 0, 84, 0, 0, 84, 
    112, 84, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 0, 0, 7,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 0, 35, 
    42, 21, 7, 0, 0, 0, 84, 84, 84, 0, 126, 0, 0, 0, 7, 0, 0, 0, 0, 0, 0, 28, 2,
    1, 0, 0, 0, 0, 0, 0, 0, 0, 14, 0, 14, 7, 0, 0, 0, 28, 0, 0, 0, 0, 42, 14, 0,
    0, 42, 28, 0, 0, 28, 0, 112, 0, 0, 0, 0, 84, 84, 0, 0, 84, 0, 84, 0, 112, 
    84, 84, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 2, 0, 4, 1,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 18, 0, 0, 0, 0, 6, 24, 0, 3, 
    0, 0, 90, 0, 72, 84, 72, 0, 36, 36, 0, 108, 0, 0, 0, 4, 0, 8, 24, 0, 0, 0, 
    0, 0, 0, 2, 0, 4, 24, 0, 0, 0, 0, 0, 42, 0, 3, 0, 8, 24, 0, 0, 0, 0, 0, 78, 
    0, 0, 0, 36, 0, 72, 0, 12, 0, 48, 0, 0, 72, 72, 54, 0, 0, 0, 90, 0, 0, 168, 
    24, 0, 72 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 2, 4, 0, 0,
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18, 18, 0, 0, 0, 6, 0, 0, 24, 0, 
    3, 90, 0, 72, 0, 84, 0, 72, 36, 36, 108, 0, 0, 0, 4, 0, 8, 0, 0, 24, 0, 0, 
    0, 0, 2, 0, 0, 24, 4, 0, 0, 0, 0, 0, 0, 42, 0, 3, 24, 8, 0, 0, 0, 0, 78, 0, 
    0, 0, 36, 0, 72, 0, 12, 0, 48, 0, 0, 0, 72, 72, 0, 54, 0, 0, 0, 90, 0, 24, 
    168, 0, 72 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 0, 0, 0, 1,
    1, 1, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 7, 8, 0, 0, 0, 0, 0, 48, 48, 16, 
    16, 32, 32, 28, 28, 0, 64, 64, 64, 64, 96, 96, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0,
    0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16, 20, 20, 0, 0, 
    64, 0, 0, 0, 0, 0, 32, 32, 64, 64, 0, 0, 0, 240, 16, 16, 0, 0, 32, 32, 0, 
    64, 64, 0, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0,
    0, 0, 0, 0, 9, 0, 0, 0, 0, 9, 3, 9, 0, 9, 0, 0, 0, 0, 27, 0, 9, 18, 0, 0, 
    27, 0, 0, 0, 27, 18, 0, 0, 27, 81, 54, 54, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0,
    0, 3, 18, 0, 9, 30, 15, 0, 0, 0, 0, 0, 0, 27, 0, 3, 27, 0, 0, 27, 27, 0, 27,
    0, 54, 0, 63, 0, 36, 27, 27, 27, 63, 0, 45, 0, 0, 81, 27, 27, 135, 54, 0, 0,
    0, 54, 81, 108 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0,
    0, 0, 0, 9, 0, 0, 0, 0, 9, 0, 3, 9, 0, 9, 0, 0, 0, 27, 0, 9, 0, 0, 18, 27, 
    0, 0, 0, 27, 0, 18, 0, 0, 81, 27, 54, 54, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 0, 
    0, 18, 3, 0, 30, 9, 0, 15, 0, 0, 0, 0, 0, 0, 27, 27, 3, 0, 0, 27, 27, 27, 0,
    0, 54, 63, 0, 36, 0, 27, 27, 63, 27, 45, 0, 0, 0, 27, 81, 135, 27, 0, 54, 0,
    54, 0, 81, 108 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 27, 0, 9, 0, 9, 0, 0, 0, 0, 0, 0, 0, 0, 45, 27, 0, 36, 0, 0, 0, 
    0, 0, 9, 0, 27, 0, 0, 0, 27, 27, 0, 27, 3, 0, 0, 0, 0, 3, 0, 0, 9, 0, 0, 0, 
    0, 0, 0, 15, 0, 48, 66, 0, 0, 45, 81, 0, 27, 9, 12, 54, 138, 27, 0, 27, 0, 
    0, 0, 0, 0, 54, 45, 54, 45, 0, 0, 0, 27, 0, 0, 0, 135, 54, 54, 27, 0, 27, 0,
    0, 0, 162, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 27, 0, 0, 9, 0, 0, 9, 0, 0, 0, 0, 0, 0, 0, 27, 45, 36, 0, 0, 0, 0, 
    0, 9, 0, 27, 0, 0, 0, 0, 27, 27, 27, 0, 0, 3, 0, 0, 3, 0, 0, 0, 0, 9, 0, 0, 
    0, 0, 0, 0, 15, 66, 48, 0, 45, 0, 0, 81, 9, 27, 54, 12, 138, 27, 27, 0, 0, 
    0, 0, 0, 54, 0, 54, 45, 0, 45, 0, 0, 0, 27, 0, 0, 54, 135, 27, 54, 27, 0, 0,
    0, 0, 162, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 63, 0, 0, 0, 0, 126, 126, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 24, 42, 42, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 21, 21, 0, 0, 
    84, 84, 21, 21, 63, 63, 0, 0, 0, 0, 0, 0, 63, 63, 63, 63, 0, 0, 0, 63, 63, 
    63, 252 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 6, 0, 15, 0, 0, 0, 0, 0, 0, 0, 5, 10, 10, 15, 30, 0, 0, 0,
    0, 0, 10, 0, 0, 0, 6, 6, 30, 15, 30, 15, 1, 0, 0, 0, 0, 0, 10, 10, 0, 0, 0, 
    5, 0, 0, 0, 0, 0, 0, 25, 40, 46, 36, 30, 0, 0, 10, 30, 10, 65, 60, 0, 0, 30,
    0, 6, 0, 70, 30, 10, 70, 60, 40, 0, 0, 45, 0, 6, 0, 90, 45, 45, 15, 75, 30, 
    0, 60, 0, 150, 60 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 6, 0, 0, 15, 0, 0, 0, 0, 0, 0, 5, 10, 10, 30, 15, 0, 0, 0,
    0, 10, 0, 0, 0, 0, 6, 6, 15, 30, 15, 30, 0, 1, 0, 0, 0, 0, 10, 10, 0, 0, 5, 
    0, 0, 0, 0, 0, 0, 25, 0, 40, 36, 46, 0, 30, 10, 0, 10, 30, 65, 60, 0, 0, 0, 
    30, 6, 0, 30, 70, 70, 10, 40, 60, 0, 0, 0, 45, 6, 0, 45, 90, 15, 45, 30, 75,
    0, 0, 60, 150, 60 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    0, 0, 0, 8, 1, 0, 4, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 36, 0, 30, 0, 0, 0, 27, 
    0, 0, 2, 0, 6, 8, 0, 24, 102, 24, 48, 24, 0, 0, 0, 5, 0, 0, 6, 0, 0, 24, 2, 
    4, 14, 0, 0, 0, 0, 36, 0, 0, 24, 0, 32, 26, 4, 0, 60, 16, 80, 24, 6, 0, 24, 
    12, 0, 0, 60, 0, 12, 0, 24, 24, 0, 24, 0, 0, 48, 0, 54, 144, 72, 0, 6, 24, 
    0, 24, 24, 180, 48 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    1, 0, 0, 1, 8, 0, 4, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 36, 0, 30, 0, 0, 0, 
    27, 2, 0, 6, 0, 8, 24, 0, 24, 102, 24, 48, 0, 0, 5, 0, 0, 0, 0, 6, 24, 0, 4,
    2, 0, 14, 0, 0, 0, 0, 36, 0, 0, 24, 26, 32, 0, 4, 16, 60, 80, 24, 0, 6, 12, 
    24, 0, 0, 0, 60, 0, 12, 24, 24, 24, 0, 0, 0, 48, 0, 144, 54, 0, 72, 24, 6, 
    0, 24, 24, 180, 48 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1, 2, 4, 0, 1,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 6, 0, 6, 4, 0, 0, 0, 0, 6, 12, 33, 
    0, 26, 0, 60, 36, 60, 0, 24, 66, 0, 156, 96, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 1, 0, 0, 12, 0, 12, 4, 0, 0, 8, 4, 0, 2, 2, 0, 0, 0, 0, 0, 54, 28, 2, 
    24, 0, 48, 28, 84, 12, 24, 24, 36, 8, 0, 0, 0, 48, 12, 36, 24, 72, 24, 48, 
    0, 8, 96, 24, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 2, 0, 4, 0,
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12, 6, 0, 6, 4, 0, 0, 0, 0, 12, 6, 0, 
    33, 0, 26, 36, 60, 60, 24, 0, 0, 66, 96, 156, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 1, 0, 0, 12, 4, 12, 0, 8, 0, 0, 4, 2, 2, 0, 0, 0, 0, 54, 0, 2, 28, 
    24, 0, 28, 48, 12, 84, 24, 24, 8, 36, 0, 0, 0, 48, 36, 12, 72, 24, 48, 24, 
    0, 96, 8, 24, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3,
    0, 0, 0, 0, 0, 3, 0, 1, 0, 0, 0, 15, 0, 0, 0, 9, 0, 0, 0, 0, 9, 0, 0, 9, 18,
    9, 27, 0, 0, 39, 72, 18, 63, 54, 72, 0, 0, 0, 3, 0, 0, 2, 6, 0, 0, 0, 6, 0, 
    2, 6, 0, 1, 9, 4, 18, 0, 18, 6, 45, 12, 0, 0, 21, 25, 8, 9, 18, 18, 0, 0, 
    18, 18, 12, 18, 0, 81, 69, 36, 9, 18, 18, 12, 0, 18, 144, 81, 27, 9, 36, 9, 
    0, 96, 12, 27, 90 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0,
    3, 0, 0, 0, 0, 3, 0, 1, 0, 0, 0, 15, 0, 0, 0, 9, 0, 0, 0, 9, 0, 0, 0, 18, 9,
    27, 9, 0, 0, 39, 18, 72, 54, 63, 0, 72, 0, 0, 0, 3, 2, 0, 0, 6, 0, 0, 0, 6, 
    6, 2, 0, 9, 1, 18, 4, 0, 6, 18, 12, 45, 0, 0, 25, 21, 8, 9, 18, 18, 0, 0, 
    18, 18, 18, 12, 81, 0, 36, 69, 18, 9, 12, 18, 0, 18, 81, 144, 9, 27, 9, 36, 
    0, 12, 96, 27, 90 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 2, 2, 0,
    0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 21, 9, 6, 0, 36, 0, 0, 0, 0, 0, 0, 0, 3, 3,
    9, 9, 9, 9, 78, 18, 18, 45, 45, 36, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 46, 46, 0, 39, 39, 60, 60, 0, 0, 8, 8, 34, 0, 9, 9, 0, 0, 0, 
    0, 33, 33, 54, 54, 36, 36, 9, 9, 0, 0, 0, 0, 135, 135, 27, 27, 36, 36, 0, 
    18, 18, 63, 0 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2,
    2, 1, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 8, 16, 0, 0, 0, 2, 2, 2, 2, 0, 0, 24, 
    24, 0, 0, 4, 4, 48, 16, 16, 32, 32, 72, 72, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 0,
    0, 0, 0, 4, 0, 0, 8, 8, 0, 32, 32, 16, 16, 0, 0, 8, 8, 0, 31, 18, 18, 16, 
    16, 16, 0, 88, 88, 40, 40, 72, 72, 8, 8, 0, 0, 0, 12, 64, 64, 32, 32, 24, 
    24, 16, 32, 32, 32, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0,
    0, 1, 2, 0, 1, 0, 0, 2, 3, 1, 0, 2, 0, 0, 7, 6, 10, 2, 0, 2, 2, 0, 20, 20, 
    8, 4, 16, 20, 2, 0, 64, 64, 76, 80, 88, 40, 0, 0, 4, 0, 0, 0, 0, 6, 6, 0, 0,
    0, 0, 0, 5, 8, 8, 0, 8, 0, 0, 0, 4, 0, 0, 36, 16, 16, 8, 18, 11, 20, 0, 16, 
    16, 0, 0, 24, 16, 8, 16, 8, 24, 0, 48, 0, 48, 36, 80, 20, 24, 44, 20, 48, 
    32, 48, 48, 80, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
    0, 1, 2, 1, 0, 0, 0, 2, 1, 3, 0, 2, 0, 0, 7, 6, 10, 0, 2, 2, 2, 20, 0, 8, 
    20, 16, 4, 2, 20, 0, 64, 64, 80, 76, 40, 88, 0, 0, 0, 4, 0, 0, 6, 0, 0, 6, 
    0, 0, 0, 0, 5, 8, 8, 8, 0, 0, 0, 0, 0, 4, 36, 0, 16, 16, 8, 18, 20, 11, 16, 
    0, 16, 0, 24, 0, 8, 16, 8, 16, 0, 24, 0, 48, 48, 36, 20, 80, 44, 24, 48, 20,
    32, 48, 48, 80, 96 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    0, 0, 0, 1, 0, 0, 0, 0, 4, 0, 2, 4, 4, 0, 0, 0, 4, 0, 12, 6, 4, 0, 0, 1, 14,
    1, 15, 0, 24, 36, 24, 12, 12, 36, 48, 72, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 2, 
    6, 0, 13, 0, 0, 6, 0, 0, 8, 12, 0, 12, 6, 14, 1, 0, 0, 0, 12, 0, 12, 15, 22,
    0, 36, 12, 48, 0, 66, 24, 30, 30, 42, 32, 24, 0, 36, 48, 6, 30, 78, 90, 24, 
    48, 72, 24, 78, 156 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    1, 0, 0, 0, 1, 0, 0, 0, 0, 4, 2, 4, 4, 0, 0, 0, 4, 12, 0, 4, 6, 0, 0, 14, 1,
    15, 1, 24, 0, 36, 12, 24, 36, 12, 72, 48, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 6, 
    2, 13, 0, 0, 6, 0, 0, 0, 8, 0, 12, 6, 12, 1, 14, 0, 0, 0, 12, 12, 0, 22, 15,
    0, 36, 48, 12, 66, 0, 30, 24, 42, 30, 24, 32, 0, 36, 6, 48, 78, 30, 24, 90, 
    48, 24, 72, 78, 156 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 20, 0, 0, 0, 0, 0, 0, 10, 10, 5, 
    5, 0, 0, 0, 0, 20, 52, 52, 40, 40, 90, 90, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 10, 0, 0, 0, 0, 0, 2, 2, 0, 0, 10, 10, 10, 10, 0, 10, 10, 10, 0, 0,
    30, 55, 10, 10, 10, 10, 20, 20, 40, 40, 30, 30, 40, 60, 0, 0, 20, 20, 40, 
    40, 110, 60, 60, 40, 200 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 12, 0, 0, 0, 0, 0, 0, 12, 12, 9, 
    9, 6, 6, 6, 6, 12, 36, 36, 36, 36, 84, 84, 0, 0, 0, 0, 0, 0, 6, 6, 0, 0, 0, 
    0, 0, 0, 0, 6, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6, 6, 0, 0, 0, 0, 18, 18, 33, 
    36, 12, 12, 12, 12, 6, 6, 36, 36, 18, 18, 72, 102, 12, 12, 18, 18, 36, 36, 
    102, 84, 84, 36, 192 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
    0, 0, 0, 0, 0, 0, 1, 0, 4, 2, 2, 0, 0, 0, 0, 0, 3, 6, 5, 6, 12, 0, 0, 0, 2, 
    0, 12, 3, 18, 12, 48, 18, 30, 27, 45, 51, 0, 0, 0, 0, 0, 1, 8, 0, 3, 0, 2, 
    3, 0, 3, 0, 0, 7, 0, 6, 16, 14, 6, 15, 0, 12, 7, 4, 6, 11, 33, 0, 9, 6, 24, 
    6, 12, 47, 54, 14, 61, 42, 31, 24, 36, 27, 15, 18, 12, 45, 27, 45, 45, 81, 
    42, 24, 66, 6, 108, 126 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
    0, 0, 0, 0, 0, 0, 1, 0, 2, 4, 2, 0, 0, 0, 0, 0, 3, 5, 6, 12, 6, 0, 0, 2, 0, 
    12, 0, 18, 3, 12, 18, 48, 27, 30, 51, 45, 0, 0, 0, 0, 1, 0, 0, 8, 0, 3, 3, 
    2, 3, 0, 0, 7, 0, 6, 0, 16, 6, 14, 0, 15, 7, 12, 6, 4, 11, 33, 9, 0, 24, 6, 
    6, 12, 54, 47, 61, 14, 31, 42, 36, 24, 15, 27, 18, 12, 27, 45, 45, 45, 42, 
    81, 24, 6, 66, 108, 126 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 3, 0, 2, 0, 1, 0, 1, 0, 3, 3, 0, 0, 9, 0, 13, 3, 6, 6, 0, 0, 12,
    0, 9, 6, 12, 15, 30, 12, 15, 75, 36, 108, 0, 0, 0, 0, 0, 3, 0, 0, 13, 3, 0, 
    0, 0, 6, 0, 0, 4, 5, 6, 4, 2, 14, 3, 0, 21, 3, 0, 27, 18, 15, 6, 3, 0, 33, 
    6, 12, 14, 61, 24, 50, 12, 15, 16, 33, 18, 21, 24, 12, 63, 42, 48, 99, 42, 
    15, 24, 32, 20, 126, 120 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 3, 0, 0, 2, 0, 0, 1, 1, 0, 3, 3, 0, 0, 9, 13, 0, 6, 3, 0, 6, 12, 0,
    9, 0, 12, 6, 15, 12, 30, 75, 15, 108, 36, 0, 0, 0, 0, 3, 0, 0, 0, 3, 13, 0, 
    0, 6, 0, 0, 4, 0, 6, 5, 4, 14, 2, 0, 3, 3, 21, 27, 0, 18, 15, 3, 6, 33, 0, 
    6, 12, 61, 14, 50, 24, 15, 12, 33, 16, 21, 18, 24, 12, 42, 63, 99, 48, 15, 
    42, 24, 20, 32, 126, 120 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 6, 3, 3, 0, 0, 0, 6, 3, 0, 9, 3, 9, 7, 5, 6, 6, 2, 
    7, 6, 9, 6, 15, 18, 24, 54, 30, 48, 36, 0, 0, 0, 0, 1, 1, 8, 6, 0, 0, 0, 2, 
    0, 1, 3, 3, 3, 5, 0, 12, 12, 8, 6, 6, 6, 6, 23, 12, 12, 27, 6, 3, 12, 15, 
    12, 6, 42, 31, 12, 15, 55, 57, 18, 27, 18, 21, 36, 30, 39, 51, 33, 18, 66, 
    63, 24, 42, 42, 120, 120 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 3, 6, 3, 0, 0, 0, 6, 3, 0, 3, 9, 7, 9, 6, 5, 2, 6, 
    6, 7, 6, 9, 15, 24, 18, 30, 54, 36, 48, 0, 0, 0, 0, 1, 1, 6, 8, 0, 0, 2, 0, 
    1, 0, 3, 3, 3, 0, 5, 12, 8, 12, 6, 6, 6, 6, 12, 23, 12, 27, 3, 6, 15, 12, 
    12, 6, 31, 42, 15, 12, 57, 55, 27, 18, 21, 18, 36, 30, 51, 39, 18, 33, 63, 
    66, 24, 42, 42, 120, 120 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 1, 3, 0, 0, 0, 6, 1, 9, 3, 0, 0, 3, 3, 0, 6, 3, 0, 7, 
    0, 9, 9, 21, 31, 18, 18, 39, 27, 93, 87, 0, 0, 0, 0, 0, 2, 0, 2, 0, 2, 0, 8,
    0, 4, 6, 3, 7, 0, 0, 0, 0, 0, 0, 6, 9, 2, 3, 6, 3, 3, 9, 0, 15, 21, 24, 36, 
    24, 36, 16, 33, 18, 27, 39, 25, 26, 30, 42, 42, 24, 12, 27, 30, 45, 30, 72, 
    58, 30, 54, 210 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 1, 0, 3, 0, 0, 6, 1, 9, 3, 0, 3, 0, 0, 3, 3, 6, 7, 0, 
    9, 0, 21, 9, 31, 18, 18, 27, 39, 87, 93, 0, 0, 0, 0, 2, 0, 2, 0, 2, 0, 8, 0,
    4, 0, 6, 7, 3, 0, 0, 0, 0, 0, 6, 0, 2, 9, 6, 3, 3, 3, 0, 9, 21, 15, 24, 36, 
    36, 24, 33, 16, 27, 18, 25, 39, 30, 26, 42, 42, 12, 24, 30, 27, 30, 45, 72, 
    30, 58, 54, 210 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 5, 4, 3, 3, 6, 0, 1, 0, 0, 9, 13, 9, 6, 
    6, 9, 15, 15, 42, 24, 36, 39, 36, 135, 108, 0, 0, 0, 0, 0, 2, 0, 2, 0, 6, 0,
    0, 0, 0, 0, 0, 5, 3, 0, 0, 9, 0, 0, 0, 0, 0, 6, 4, 0, 0, 18, 0, 16, 12, 18, 
    18, 27, 15, 18, 21, 18, 21, 26, 30, 25, 25, 30, 54, 24, 27, 42, 33, 18, 30, 
    48, 58, 70, 48, 162 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 5, 4, 3, 3, 6, 1, 0, 0, 0, 13, 9, 6, 9, 
    9, 6, 15, 15, 42, 36, 24, 36, 39, 108, 135, 0, 0, 0, 0, 2, 0, 2, 0, 6, 0, 0,
    0, 0, 0, 0, 5, 0, 0, 3, 0, 0, 9, 0, 0, 0, 0, 4, 6, 0, 0, 0, 18, 12, 16, 18, 
    18, 15, 27, 21, 18, 21, 18, 30, 26, 25, 25, 30, 54, 27, 24, 33, 42, 30, 18, 
    48, 70, 58, 48, 162 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 5, 5, 0, 0, 0, 0, 5, 5, 15, 
    15, 10, 10, 10, 10, 35, 66, 66, 35, 35, 70, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 5, 5, 0, 0, 0, 0, 0, 0, 1, 1, 10, 10, 0, 0, 0, 0, 0, 0, 15, 15, 0, 
    0, 20, 60, 15, 15, 20, 20, 30, 30, 35, 35, 25, 25, 2, 50, 25, 25, 60, 60, 
    40, 40, 80, 60, 60, 50, 95 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 7, 0, 0, 0, 0, 2, 2, 4, 4, 6, 6, 
    4, 4, 5, 5, 8, 44, 44, 32, 32, 68, 68, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 4, 4, 
    4, 4, 15, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 8, 4, 4, 0, 3, 9, 9, 12, 12, 24, 68,
    8, 8, 8, 8, 20, 20, 28, 28, 36, 36, 40, 65, 8, 8, 28, 28, 34, 34, 132, 68, 
    68, 48, 216 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 3, 0, 0, 2, 0, 1, 0, 2, 0, 0, 0, 0, 1, 4, 8, 10, 14, 5, 1, 0, 4, 4,
    4, 0, 6, 2, 14, 16, 32, 35, 36, 52, 34, 0, 0, 0, 1, 0, 0, 0, 6, 0, 4, 0, 4, 
    3, 0, 1, 6, 2, 10, 4, 8, 12, 6, 9, 24, 2, 6, 32, 18, 30, 16, 20, 5, 16, 2, 
    0, 8, 30, 18, 42, 28, 26, 34, 16, 8, 16, 18, 20, 8, 76, 84, 32, 42, 41, 44, 
    24, 40, 44, 162, 120 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 3, 0, 2, 0, 0, 1, 2, 0, 0, 0, 0, 1, 4, 10, 8, 5, 14, 0, 1, 4, 4,
    0, 4, 2, 6, 14, 32, 16, 36, 35, 34, 52, 0, 0, 1, 0, 0, 0, 6, 0, 4, 0, 4, 0, 
    0, 3, 1, 2, 6, 4, 10, 8, 6, 12, 24, 9, 6, 2, 18, 32, 30, 16, 5, 20, 2, 16, 
    0, 8, 18, 30, 28, 42, 34, 26, 8, 16, 18, 16, 20, 8, 84, 76, 42, 32, 44, 41, 
    24, 44, 40, 162, 120 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
    0, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 1, 2, 6, 1, 5, 0, 0, 1, 4, 6, 4, 4, 
    7, 15, 12, 26, 44, 24, 8, 44, 20, 94, 80, 0, 0, 0, 0, 0, 1, 4, 1, 2, 0, 4, 
    0, 0, 0, 0, 2, 10, 4, 2, 8, 6, 2, 12, 0, 4, 12, 6, 2, 6, 8, 6, 11, 10, 26, 
    8, 12, 30, 30, 32, 66, 22, 12, 18, 20, 28, 22, 48, 28, 32, 42, 55, 42, 40, 
    24, 32, 60, 40, 54, 160 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0,
    0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 2, 6, 1, 0, 5, 1, 0, 6, 4, 4, 4, 
    15, 7, 26, 12, 44, 8, 24, 20, 44, 80, 94, 0, 0, 0, 0, 1, 0, 1, 4, 0, 2, 0, 
    4, 0, 0, 0, 10, 2, 2, 4, 8, 2, 6, 0, 12, 12, 4, 2, 6, 6, 8, 11, 6, 26, 10, 
    8, 12, 30, 30, 66, 32, 12, 22, 20, 18, 22, 28, 48, 28, 42, 32, 42, 55, 24, 
    40, 32, 40, 60, 54, 160 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 6, 5, 1, 2, 6, 6, 0, 1, 1, 5, 0, 16, 10,
    4, 0, 18, 5, 34, 12, 32, 72, 32, 102, 66, 0, 0, 0, 0, 2, 0, 1, 2, 0, 6, 4, 
    0, 5, 0, 2, 4, 0, 0, 2, 0, 10, 4, 1, 4, 4, 8, 8, 2, 8, 6, 5, 12, 30, 8, 16, 
    24, 54, 28, 28, 10, 44, 42, 30, 20, 12, 20, 32, 34, 41, 44, 40, 24, 23, 44, 
    44, 28, 44, 62, 152 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    1, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 6, 5, 1, 2, 6, 0, 6, 1, 1, 0, 5, 10, 16,
    0, 4, 5, 18, 34, 32, 12, 32, 72, 66, 102, 0, 0, 0, 0, 0, 2, 2, 1, 6, 0, 0, 
    4, 0, 5, 2, 0, 4, 2, 0, 0, 4, 10, 4, 1, 8, 4, 2, 8, 8, 6, 12, 5, 8, 30, 16, 
    24, 28, 54, 10, 28, 42, 44, 20, 30, 20, 12, 32, 34, 44, 41, 24, 40, 44, 23, 
    44, 44, 28, 62, 152 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 12, 12, 6, 6,
    6, 6, 6, 6, 36, 30, 30, 36, 36, 102, 102, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 6, 6, 12, 12, 33, 
    51, 12, 12, 12, 12, 12, 12, 36, 36, 24, 24, 48, 99, 18, 18, 24, 24, 33, 33, 
    87, 60, 60, 36, 228 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 3, 0, 2, 3, 0, 2, 0, 0, 3, 0, 0, 6, 12, 3, 
    7, 0, 6, 0, 21, 39, 36, 57, 33, 114, 75, 0, 0, 0, 0, 0, 0, 1, 1, 1, 3, 3, 4,
    7, 1, 3, 0, 3, 0, 0, 6, 6, 0, 3, 3, 1, 12, 16, 2, 3, 6, 9, 9, 18, 6, 18, 42,
    33, 3, 16, 10, 21, 21, 29, 15, 29, 35, 36, 51, 30, 33, 45, 30, 21, 33, 60, 
    52, 68, 51, 186 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 3, 0, 2, 3, 0, 2, 0, 0, 0, 3, 6, 0, 3, 12, 
    0, 7, 0, 6, 21, 36, 39, 33, 57, 75, 114, 0, 0, 0, 0, 0, 0, 1, 1, 3, 1, 4, 3,
    1, 7, 3, 3, 0, 0, 0, 6, 0, 6, 3, 3, 12, 1, 2, 16, 3, 6, 9, 9, 6, 18, 18, 42,
    3, 33, 10, 16, 21, 21, 15, 29, 35, 29, 36, 51, 33, 30, 30, 45, 33, 21, 60, 
    68, 52, 51, 186 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 2, 0, 1, 0, 0, 0, 5, 5, 4, 0, 8, 0, 2, 2, 1, 1, 2, 2, 6, 6, 
    7, 7, 9, 9, 56, 20, 20, 38, 38, 71, 71, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 2, 
    0, 0, 0, 3, 3, 6, 6, 4, 10, 10, 15, 15, 2, 2, 3, 3, 7, 4, 10, 10, 13, 13, 8,
    12, 36, 36, 42, 42, 40, 40, 18, 18, 16, 16, 20, 24, 81, 81, 27, 27, 31, 31, 
    24, 34, 34, 78, 164 ],
    [ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 5, 2, 2, 2, 2, 6, 6, 3, 3, 
    4, 4, 7, 7, 21, 32, 32, 31, 31, 82, 82, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    1, 1, 0, 2, 2, 0, 0, 8, 2, 2, 2, 2, 4, 4, 5, 5, 0, 6, 6, 6, 13, 13, 20, 32, 
    21, 21, 20, 20, 20, 20, 35, 35, 27, 27, 19, 54, 30, 30, 40, 40, 38, 38, 76, 
    62, 62, 82, 198 ]
]
;
