IsDistance3_Soft_Base := function(x)
T1 := {[3,21,0],[2,14,8],[2,16,6],[2,0,22],[1,7,16]};
T2 := {[1,1,22],[0,8,16],[0,2,22],[0,24,0]};

p := TransProfile(x);

if p in T1 then
        if p eq [3,21,0] then
                return [3,3] ;
        end if;
        if p eq [2,14,8] then
                return [3,4] ;
        end if;
        if p eq [2,16,6] then
                return [3,5] ;
        end if;
        if p eq [2,0,22] then
                return [3,1] ;
        end if;
        if p eq [1,7,16] then
                return [3,8] ;
        end if;
end if;

if p in T2 then
        return [1,0];
end if;

if not(p in T1) and not(p in T2) then
        return [0,0];
end if;

end function;


IsDistance3_Hard := function(t)
x:=a^t;
r:=[0,0];
O := OctTran^t;
p:=TransProfile(x);

if p eq [1,1,22] then
for i in [1 .. 1518] do
        if #(x meet Neighboursa[i]) eq 2 and #(O meet Neighboursa[i]) eq 6 
then
                r := [3,9];
        end if;
end for;
end if;

if p eq [0,8,16] then
for i in [1 .. 1518] do
        if #(x meet Neighboursa[i]) eq 2 and #(O meet Neighboursa[i]) eq 6 
then
                r := [3,6];
        end if;
end for;
end if;

if p eq [0,2,22] then
for i in [1 .. 1518] do
        if #(x meet Neighboursa[i]) eq 2 and #(O meet Neighboursa[i]) eq 6 
then
                r := [3,10];
        end if;
end for;
end if;

if p eq [0,24,0] then
        for i in [1 .. 1518] do
                if #(x meet Neighboursa[i]) eq 4 then
                r := [3,2];
        end if;
end for;
end if;

if TransProfile(x) eq [0,8,16] then
        for i in [1 .. 1518] do
                if #(x meet Neighboursa[i]) eq 4 then
                r := [3,7];
        end if;
end for;
end if;
if r eq [0,0] then
        return [0,0];
else
        return r;
end if;
end function;

IsDistance3 := function(t)
x := a^t;
q := IsDistance3_Soft_Base(x);

if q eq [0,0] then
        return q;
end if;

if q eq [1,0] then
        q2 := IsDistance3_Hard(t);
        return q2;
end if;

if not(q eq [1,0]) or not(q eq [0,0]) then
        return q;
end if;

end function;
