WhereAmI := function(g)
// function which outputs which orbit a^g is in
	x := a^g;
	t := TransProfile(x);
	q := IsDistance3(g);
	if t eq [24,0,0] then
		return [0,1];
	end if;
	if t eq [8,16,0] then
		return [1,1];
	end if;
	if t eq [0,24,0] and q[1] eq 0 then
		return [2,1];	
	end if;
	if t eq [4,20,0] then
		return [2,2];
	end if;
	if t eq [2,6,16] then
		return [2,3];
	end if;
	if q[1] eq 3 then
		return q;
	end if;
	if t eq [0,8,16] and q[1] eq 0 then
		MultiplyRandomWord(~h,Disc4Orbit8,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,8];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit9,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,9];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit10,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,10];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit11,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,11];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit12,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,12];
		end if;
	end if;
	if t eq [1,1,22] and q[1] eq 0 then
		return [4,7];
	end if;
	if t eq [0,16,8] then
		MultiplyRandomWord(~h,Disc4Orbit1,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,1];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit2,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,2];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit1,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,1];
		end if;		
		MultiplyRandomWord(~h,Disc5Orbit2,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,2];
		end if;
	end if;	
	if t eq [1,15,8] then
		return [4,3];
	end if;
	if t eq [0,0,24] then
		MultiplyRandomWord(~h,Disc4Orbit4,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,4];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit13,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,13];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit25,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,25];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit32,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,32];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit33,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,33];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit15,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,15];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit35,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,35];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit36,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,36];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit48,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,48];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit55,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,55];
		end if;
	end if;
	if t eq [0,10,14] then
		MultiplyRandomWord(~h,Disc4Orbit14,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,14];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit15,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,15];
		end if;
	end if;
	if t eq [1,9,14] then
		return [4,16];
	end if;
	if t eq [1,11,12] then	
		return [4,17];
	end if;
	if t eq [1,3,20] then
		return [4,18];
	end if;
	if t eq [0,4,20] then
		MultiplyRandomWord(~h,Disc4Orbit22,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,22];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit23,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,23];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit24,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,24];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit5,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,5];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit6,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,6];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit7,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,7];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit8,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,8];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit9,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,9];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit10,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,10];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit27,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,27];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit28,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,28];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit30,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,30];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit49,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,49];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit50,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,50];
		end if;
	end if;
	if t eq [1,5,18] then
		return [4,21];
	end if;	
	if t eq [0,6,18] then
		MultiplyRandomWord(~h,Disc4Orbit19,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,19];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit20,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,20];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit26,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,26];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit28,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,28];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit29,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,29];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit30,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,30];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit31,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,31];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit3,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,3];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit4,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,4];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit21,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,21];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit22,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,22];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit23,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,23];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit24,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,24];
		end if;
	end if;
	if t eq [0,1,23] then
		MultiplyRandomWord(~h,Disc4Orbit41,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,41];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit42,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,42];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit45,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,45];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit46,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,46];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit43,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,43];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit44,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,44];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit45,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,45];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit46,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,46];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit47,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,47];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit56,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,56];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit57,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,57];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit59,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,59];
		end if;
	end if;
	if t eq [0,3,21] then
		MultiplyRandomWord(~h,Disc5Orbit16,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,16];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit17,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,17];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit20,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,20];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit37,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,37];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit38,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,38];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit39,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,39];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit40,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,40];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit41,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,41];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit42,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,42];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit58,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,58];
		end if;
	end if;
	if t eq [0,7,17] then
		return [5,29];
	end if;
	if t eq [0,9,15] then
		MultiplyRandomWord(~h,Disc5Orbit18,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,18];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit19,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,19];
		end if;
	end if;
	if t eq [0,2,22] and q[1] eq 0 then
		MultiplyRandomWord(~h,Disc4Orbit5,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,5];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit6,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,6];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit27,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,27];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit34,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,34];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit35,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,35];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit36,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,36];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit37,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,37];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit38,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,38];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit39,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,39];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit40,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,40];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit43,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,43];
		end if;
		MultiplyRandomWord(~h,Disc4Orbit44,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [4,44];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit11,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,11];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit12,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,12];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit13,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,13];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit14,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,14];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit25,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,25];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit26,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,26];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit31,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,31];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit32,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,32];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit33,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,33];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit34,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,34];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit51,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,51];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit52,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,52];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit53,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,53];
		end if;
		MultiplyRandomWord(~h,Disc5Orbit54,G);	
		if IsConjugate(Ga,a^g,a^h) eq true then
			return [5,54];
		end if;
	end if;
end function;
